package org.mandarax.xkb.framework;

/**
 *  Copyright (C) 1999-2004  Jens Dietrich (mailto:mandarax@jbdietrich.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


/**
 * Default driver. We keep a version name in the class name since we will maintain
 * drivers in order to migrate data between drivers. Support for the following features has been added:
 * <li>
 * <ol>negation is rule bodies (negation as failure)
 * <ol>close connection property in SQLClauseSet and SQLFunction
 * <ol>additional properties in clause sets and queries
 * </li>
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 2.0
 */
public class XKBDriver_2_0 extends GenericDriver {

	/**
	 * Constructor.
	 */
	public XKBDriver_2_0() {
	      super();
	      initialize();
	}
	/**
	 * Get the name of the driver.
	 * @return a text
	 */
	public String getName() {
		return "Mandarax XKB Driver 2.0";
	}
	/**
	 * Initialize the object.
	 */
	protected void initialize() {
	      install(new XMLAdapter4ComplexTerms());
	      install(new XMLAdapter4ConstantTerms());
	      install(new XMLAdapter4Facts2());
	      install(new XMLAdapter4KnowledgeBases());
	      install(new XMLAdapter4MandaraxLibFunctions());
	      install(new XMLAdapter4MandaraxLibPredicates());
	      install(new XMLAdapter4Methods());
	      install(new XMLAdapter4Objects());
	      install(new XMLAdapter4Rules2());
	      install(new XMLAdapter4Prerequisites());
	      install(new XMLAdapter4SimplePredicates());
	      install(new XMLAdapter4SQLClauseSets2());
	      install(new XMLAdapter4SQLPredicates());
	      install(new XMLAdapter4SQLFunctions2());
	      install(new XMLAdapter4Types());
	      install(new XMLAdapter4VariableTerms());
	      install(new XMLAdapter4DataSources());
	      install(new XMLAdapter4JFunctions());
	      install(new XMLAdapter4DynaBeanFunctions());
	      install(new XMLAdapter4JPredicates());
	      install(new XMLAdapter4Queries2());
	}
    /**
     * Indicates whether the driver (and the underlying xml format (=dtd))
     * supports queries.
     * @return a boolean
     */
    public boolean supportsQueries() {
    	return true;
    }
    /**
	 * Indicates whether the driver (and the underlying xml format (=dtd))
	 * supports negation as failure.
	 * @return a boolean
	 */
	public boolean supportsNegationAsFailure(){
		return true;
	}
}
